import java.util.*;
import java.io.*;

public class C {
	FastScanner in;
	PrintWriter out;

	static int[][][] was;
	static char[] s;
	static char[][] c;

	static int cn;
	static int[] pathDir;
	static int[] path;

	static final char[] DIR = "DRUL".toCharArray();

	static int n, m, len;

	static final int INF = 1 << 30;
	static final int[] DX = { 1, 0, -1, 0 }, DY = { 0, 1, 0, -1 };

	static int dfs(int step, int x, int y) {
		was[step][x][y] = cn;
		char next = s[(step + 1) % len];
		for (int dir = 0; dir < 4; dir++) {
			int nx = x + DX[dir];
			int ny = y + DY[dir];
			if (nx < 0 || ny < 0 || nx >= n || ny >= m || next != c[nx][ny]) {
				continue;
			}
			int got = was[(step + 1) % len][nx][ny];
			if (got == INF) {
				continue;
			}
			if (got >= 0) {
				pathDir[cn++] = dir;
				return got;
			}
			pathDir[cn++] = dir;
			got = dfs((step + 1) % len, nx, ny);
			if (got >= 0) {
				return got;
			}
		}
		--cn;
		was[step][x][y] = INF;
		return -1;
	}

	void solve() throws IOException {
		n = in.nextInt();
		m = in.nextInt();
		len = in.nextInt();
		c = new char[n][];
		for (int i = 0; i < n; i++) {
			c[i] = in.next().toCharArray();
		}
		s = in.next().toCharArray();
		// {
		// for (int k = 1; k <= s.length; k++) {
		// boolean ok = true;
		// for (int i = 0; i + k < s.length; i++) {
		// if (s[i] != s[i + k]) {
		// ok = false;
		// break;
		// }
		// }
		// if (ok) {
		// len = k;
		// s = Arrays.copyOf(s, len);
		// break;
		// }
		// }
		// }
		was = new int[s.length][n][m];
		for (int[][] e : was) {
			for (int[] f : e) {
				Arrays.fill(f, -1);
			}
		}
		pathDir = new int[n * m * s.length];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (c[i][j] != s[0])
					continue;
				if (was[0][i][j] == -1) {
					cn = 0;
					int got = dfs(0, i, j);
					if (got >= 0) {
						int cx = i;
						int cy = j;
						int cur = 0;
						while (cur < got) {
							cx += DX[pathDir[cur]];
							cy += DY[pathDir[cur]];
							++cur;
						}
						out.println("YES");
						out.println(cn - got);
						int shift = (got % len) % len;
						for (int e = cn - 1; e >= cn - shift; e--) {
							cx -= DX[pathDir[e]];
							cy -= DY[pathDir[e]];
							if (shift == 0)
								break;
						}
						out.println((cx + 1) + " " + (cy + 1));
						for (int e = cn - shift; e < cn; e++) {
							out.print(DIR[pathDir[e]]);
						}
						for (int e = got; e < cn - shift; e++) {
							out.print(DIR[pathDir[e]]);
						}
						out.println();
						return;
					}
				}
			}
		}
		out.println("NO");
	}

	void run() throws IOException {
		in = new FastScanner();
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String next() {
			try {
				while (st == null || !st.hasMoreElements()) {
					st = new StringTokenizer(br.readLine());
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}
	}

	public static void main(String[] args) throws IOException {
		new C().run();
	}

}
