import java.util.*;
import java.io.*;

public class C {

	int n, m, l;
	int[][][] vis;
	char[][] a;
	String s;

	String dirs = "ULDR";
	int[] dx = new int[] {-1, 0, 1, 0};
	int[] dy = new int[] {0, -1, 0, 1};
	
	
	int[] stack;
	int stackHead = 0;
	char[] stackD;
	int stackDHead = 0;
	
	boolean go(int r, int c, int pos) {
		vis[r][c][pos] = 1;
		stack[stackHead++] = r;
		stack[stackHead++] = c;
		stack[stackHead++] = pos;
		for (int d = 0; d < 4; d++) {
			int newR = r + dx[d], newC = c + dy[d];
			if (0 <= newR && newR < n && 0 <= newC && newC < m) {
				int newPos = pos + 1;
				if (newPos == s.length()) {
					newPos = 0;
				}
				if (a[newR][newC] != s.charAt(newPos)) {
					continue;
				}
				if (vis[newR][newC][newPos] == 0) {
					stackD[stackDHead++] = dirs.charAt(d);
					if (go(newR, newC, newPos)) {
						return true;
					}
					stackDHead--;
				} else if (vis[newR][newC][newPos] == 1) {
					StringBuilder result = new StringBuilder();
					result.append(dirs.charAt(d));
					int savedR = -1, savedC = -1;
					int savedPos = 0;
					while (true) {
						int spos = stack[--stackHead];
						int sc = stack[--stackHead];
						int sr = stack[--stackHead];
						if (spos == 0) {
							savedR = sr + 1;
							savedC = sc + 1;
							savedPos = result.length();
						}
						if (spos == newPos && sc == newC && sr == newR) {
							break;
						}
						result.append(stackD[--stackDHead]);

					}
					String answer = result.reverse().toString();
					out.println("YES");
					out.println(result.length());
					out.println(savedR + " " + savedC);
					out.println(answer.substring(answer.length() - savedPos) + answer.substring(0, answer.length() - savedPos));
					return true;
				}
			}
		}
		stackHead -= 3;
		vis[r][c][pos] = 2;
		return false;
	}

	void solve() {
		n = in.nextInt();
		m = in.nextInt();
		l = in.nextInt();
		a = new char[n][m];
		for (int i = 0; i < n; i++) {
			a[i] = in.nextToken().toCharArray();
		}

		s = reduce(in.nextToken());
		vis = new int[n][m][l];
		stack = new int[n * m * l * 3];
		stackD = new char[n * m * l];
		
		for (int i =0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (vis[i][j][0] == 0) {
					if (go(i, j, 0)) {
						return;
					}
				}
			}
		}
		out.println("NO");
	}

	String reduce(String s) {
		for (int i = 1; i <= s.length(); i++) {
			if (s.length() % i != 0) {
				continue;
			}
			boolean ok = true;
			for (int j = i; j < s.length(); j++) {
				if (s.charAt(j) != s.charAt(j - i)) {
					ok = false;
				}
			}
			if (ok) {
				return s.substring(0, i);
			}
		}
		return s;
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new C().run();
	}
}
