#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
using namespace std;

#define name ""
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)

const int dd = 5e3 + 7;

bool dp[dd];

vector<int> Z(string s) {
	int n = s.size();
	vector<int> z(n);
	for (int i = 1, l = 0, r = 0; i < n; ++i) {
		if (i <= r){
			z[i] = min(r - i + 1, z[i - l]);
		}	
		while (i + z[i] < n && s[z[i]] == s[i + z[i]]){
			++z[i];
		}
		if (i + z[i] - 1 > r){
			l = i;
			r = i + z[i] - 1;
		}
	}
	return z;
}

int main(){
	int n;
	string a, b;
	cin >> n >> a >> b;
	dp[n] = 1;
	for (int i = n; i > 0; i--){
		if (dp[i]){
			string w;
			fornn(j, n - i, n){
				w.push_back(a[j]);
			}
			w.push_back('#');
			forn(j, i){
				w.push_back(b[j]);
			}
			vector<int> F = Z(w);
			forn(j, i){
				int s = j + i + 1;
				if(F[s] == i - j){
					dp[j] = 1;
				}
			}
		}
	}
	if(dp[0]){
		cout << "Yes\n";
	}
	else{
		cout << "No\n";
	}
}