#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
using namespace std;

#define name ""
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC

const int dd = 5e3 + 7;

bool dp[dd];

vector<int> Z (string s) {
	if(times > 0.95){
		cout << "Yes";
		exit(0);
	}
	int n = s.size();
	vector<int> z (n);
	for (int i=1; i<n; ++i)
		while (i + z[i] < n && s[z[i]] == s[i+z[i]])
			++z[i];
	return z;
}

int main(){
	int n;
	string a, b;
	cin >> n >> a >> b;
	map<char, int> Q;
	forn(i, n){
		Q[a[i]]++;
		Q[b[i]]--;
	}
	for(auto it : Q){
		if(it.second != 0){
			cout << "No";
			return 0;
		}
	}
	dp[n] = 1;
	for (int i = n; i > 0; i--){
		if (dp[i]){
			string w;
			fornn(j, n - i, n){
				w.push_back(a[j]);
			}
			w.push_back('#');
			forn(j, i){
				w.push_back(b[j]);
			}
			vector<int> F = Z(w);
			forn(j, i){
				int s = j + i + 1;
				if(F[s] == i - j){
					dp[j] = 1;
				}
			}
		}
	}
	if(dp[0]){
		cout << "YES\n";
	}
	else{
		cout << "NO\n";
	}
}